
// Macro_for_pol
// Generates a surface stack from a shape image sequence


run("Close All");

// Size must be adapted to the size of the shape images
newImage("tot1", "8 bit", 134, 134, 1);
newImage("tot2", "8 bit", 134, 134, 1);
newImage("1", "8 bit", 134, 134, 1);
newImage("2", "8 bit", 134, 134, 1);
newImage("3", "8 bit", 134, 134, 1);

run("Open...");

selectWindow("shape0001.tif");
run("Select All");
run("Copy");
selectWindow("1");
run("Paste");
selectWindow("tot1");
run("Paste");
selectWindow("tot2");
run("Paste");
run("Add Slice");

selectWindow("shape0001.tif");
run("Open Next");
rename("shape0001.tif");
run("Select All");
run("Copy");
selectWindow("2");
run("Paste");

for (a=1; a<51; a++) {		// write nb of slices - 1

selectWindow("shape0001.tif");
run("Open Next");
rename("shape0001.tif");
run("Select All");
run("Copy");
selectWindow("3");
run("Paste");

selectWindow("1");
run("Invert LUT");
run("Erode");
run("Invert LUT");
imageCalculator("Subtract create", "2","1");
run("Select All");
run("Copy");
close();
selectWindow("tot1");
run("Add Slice");
run("Paste");

selectWindow("3");
run("Invert LUT");
run("Erode");
run("Invert LUT");
imageCalculator("Subtract create", "2","3");
run("Select All");
run("Copy");
close();
selectWindow("tot2");
run("Paste");
run("Add Slice");

selectWindow("2");
run("Select All");
run("Copy");
selectWindow("1");
run("Paste");

selectWindow("shape0001.tif");
run("Select All");
run("Copy");
selectWindow("2");
run("Paste");

}

selectWindow("1");
close();
selectWindow("2");
close();
selectWindow("3");
close();

selectWindow("tot1");
run("Add Slice");

selectWindow("shape0001.tif");
run("Select All");
run("Copy");
selectWindow("tot2");
run("Paste");

selectWindow("shape0001.tif");
close();

imageCalculator("Add create stack", "tot1","tot2");

run("Edit LUT...");

// LUT must be inverted here

// Note that the macro can show bugs, the final stack should be checked.

